/*
 * CPMU.c
 *
 *  Created on: Mar 11, 2013
 *      Author: B34981
 */

#ifndef CPMU_H_
#define CPMU_H_

/**********************************************************************************************
* Includes
**********************************************************************************************/
#include "derivative.h"

/**********************************************************************************************
* Constants
**********************************************************************************************/


/**********************************************************************************************
* Macros
**********************************************************************************************/
                
/**********************************************************************************************
* Types
**********************************************************************************************/


/**********************************************************************************************
* Variables
**********************************************************************************************/


/**********************************************************************************************
* Global Variables
**********************************************************************************************/


/**********************************************************************************************
* Global Functions
**********************************************************************************************/

/***********************************************************************************************
*
* @brief    PLL_Init - Clock configurations (32 MHz from 4 MHz OSC)
* @param    none
* @return   none
*
************************************************************************************************/ 
void PLL_Init(void);

/***********************************************************************************************
*
* @brief    RTI_Init - Configure RTI to execute each 5 ms
* @param    none
* @return   none
*
************************************************************************************************/  
void RTI_Init(void);

/***********************************************************************************************
*
* @brief    RTI_Disable - Stop the RTI timer
* @param    none
* @return   none
*
************************************************************************************************/  
void RTI_Disable(void);

/***********************************************************************************************
*
* @brief    RTI_CheckTimer - Check the timer interrupt flag measuring 100 ms
* @param    none
* @return   none
*
************************************************************************************************/ 
UINT8 RTI_CheckTimer(void);

#endif /* CPMU_H_ */
