/*
 * FTMRZ.h
 *
 *  Created on: Mar 15, 2013
 *      Author: B34981
 */

#ifndef FTMRZ_H_
#define FTMRZ_H_

/**********************************************************************************************
* Includes
**********************************************************************************************/
#include "derivative.h"


/**********************************************************************************************
* Constants
**********************************************************************************************/


/**********************************************************************************************
* Macros
**********************************************************************************************/

                
/**********************************************************************************************
* Types
**********************************************************************************************/
typedef struct
{
	UINT8 Data[8];
	union
	{
		UINT8 	Byte[4];				/* Byte level access to the Address */
		UINT32 	DWord;				/* DWord level access to the Address */
	} Add;
}ProgramStruct;

/**********************************************************************************************
* Variables
**********************************************************************************************/


/**********************************************************************************************
* Global Variables
**********************************************************************************************/


/**********************************************************************************************
* Global Functions
**********************************************************************************************/

/***********************************************************************************************
*
* @brief    FTMRZ_Erase_Flash - Erase flash registers except the Bootloader region
* @param    defines in Main.h
* @return   none
*
************************************************************************************************/  
#pragma CODE_SEG SHADOW_ROM

void FTMRZ_Erase_Flash(void);
void FTMRZ_Prog_Phrase(void);

#pragma CODE_SEG DEFAULT

void FTMRZ_Init(void);

#endif /* FTMRZ_H_ */
